﻿break

#region Assign variables.
$Path1 = "$env:USERPROFILE\Documents\PowerShell\Saturday\Arizona 2017\Session I\Files\New-RandomPassword1.0.ps1"
$Path2 = "$env:USERPROFILE\Documents\PowerShell\Saturday\Arizona 2017\Session I\Files\New-RandomPassword2.0.ps1"
$AdvTemp2 = "$env:USERPROFILE\Documents\PowerShell\Saturday\Arizona 2017\Session I\Files\AdvancedFunctionTemplate2.0.ps1"

Clear-Host
#endregion

#-------------------------------------------------

#region Remove New-RandomPassword function.
Remove-Item -Path Function:\New-RandomPassword -ErrorAction SilentlyContinue
#endregion

#region Check if New-RandomPassword function is loaded.
New-RandomPassword
#endregion

#region Load New-RandomPassword1.0.ps1.
. $Path1
#endregion

#region New-RandomPassword function.
Get-Item -Path Function:\New-RandomPassword -ErrorAction SilentlyContinue

Clear-Host

New-RandomPassword
#endregion

#region Length.
New-RandomPassword -Length 4

New-RandomPassword -Length 35

New-RandomPassword -Length 3

New-RandomPassword -Length 36

Clear-Host
#endregion

#region CharacterType.
New-RandomPassword -CharacterType Lowercase,Number,Symbol,Uppercase

New-RandomPassword -CharacterType Lowercase,Number,Uppercase

New-RandomPassword -CharacterType Number,Symbol

New-RandomPassword -CharacterType Symbol

New-RandomPassword -CharacterType Symbol -Length 35

Clear-Host
#endregion

#region UnusedCharacter.
New-RandomPassword -UnusedCharacter o,O,0

New-RandomPassword -CharacterType Lowercase,Number -UnusedCharacter 0,1,2,3,4,5,6,7

Clear-Host
#endregion

#region Advanced Function Template 1.0 (how to log included).
New-RandomPassword -Verbose

# Show how to log with Write-Verbose commands.
code $Path1

Clear-Host

New-RandomPassword -Log

Clear-Host

Invoke-Item -Path /

New-RandomPassword -Verbose -Log

Clear-Host

New-RandomPassword -Length 15 -CharacterType Lowercase,Number -UnusedCharacter 0,1,2,3,4,5,6,7 -Verbose -Log

Clear-Host

1..10 | ForEach-Object {New-RandomPassword -Verbose -Log}

Clear-Host
#endregion

#-------------------------------------------------

#region Load New-RandomPassword2.0.ps1.
. $Path2
#endregion

#region New-RandomPassword function.
New-RandomPassword
#endregion

#region Length.
New-RandomPassword -Length 4

New-RandomPassword -Length 35

Clear-Host
#endregion

#region CharacterType.
New-RandomPassword -CharacterType Symbol

New-RandomPassword -CharacterType Number,Symbol

Clear-Host
#endregion

#region UnusedCharacter.
New-RandomPassword -UnusedCharacter o,O,0

New-RandomPassword -CharacterType Lowercase,Number -UnusedCharacter 0,1,2,3,4,5,6,7

Clear-Host
#endregion

#region Advanced Function Template 2.0.
New-RandomPassword -Verbose

Clear-Host

New-RandomPassword -Log

Clear-Host

New-RandomPassword -Log ToScreen

Clear-Host

New-RandomPassword -Log ToScreen -Length 21

Clear-Host

New-RandomPassword -Log ToScreen -Length 21 -CharacterType Number,Symbol

Clear-Host

New-RandomPassword -Log ToScreen -Length 21 -CharacterType Number,Symbol -UnusedCharacter 0,1,2,3,4,5,6,7

Clear-Host

New-RandomPassword -Log ToScreenAndFile

Clear-Host

New-RandomPassword -Log ToFile

Clear-Host

1..10 | ForEach-Object {New-RandomPassword -Log ToFile}

Clear-Host
#endregion

#region Environment parameter.
New-RandomPassword -Log ToFile -Environment DEV

New-RandomPassword -Log ToFile -Environment PRD

New-RandomPassword -Log ToFile -Environment NON-PRD

Clear-Host
#endregion

#-------------------------------------------------

#region $PSDefaultParameterValues.
$PSDefaultParameterValues.Clear()

$PSDefaultParameterValues

$PSDefaultParameterValues.Add('New-RandomPassword:Log','ToFile')

$PSDefaultParameterValues

Clear-Host

New-RandomPassword

New-RandomPassword -Length 20 -UnusedCharacter 0,1,2,3,4,5

Clear-Host
#endregion

#-------------------------------------------------

#region Open Advanced Function Template 2.0 in VSCode.
code $AdvTemp2
#endregion